<template>
    <div>
        <Header/>
        <router-view
            v-bind:cms="cms"
            v-bind:fullHeight="fullHeight"
            v-bind:loader="loader"
            v-bind:contentWayPoint="contentWayPoint"
        />
        <Footer/>
    </div>
</template>

<script type="text/babel">

    import Header from '../components/layouts/Header';
    import Footer from '../components/layouts/Footer';

    export default {
        name: 'app',
        components: {
            Header,
            Footer,
        },
        data() {
            return {
                config: {
                    baseUrl: document.querySelector('meta[name=base-url]').getAttribute("content")
                },
                cms: {
                    // initializing with empty until we get data from api
                    about: {
                        name: '',
                        job_title: ''
                    }
                },
            }
        },
        methods: {
            initTokens() {
                // csrf token for forms
                //this.tokens.csrf_token = $("meta[name=csrf-token]").attr("content");
            },
            fullHeight() {

                $('.js-fullheight').css('min-height', $(window).height());
                $(window).resize(function () {
                    $('.js-fullheight').css('min-height', $(window).height());
                });

            },
            loader() {
                setTimeout(function () {
                    if ($('#ftco-loader').length > 0) {
                        $('#ftco-loader').removeClass('show');
                    }
                }, 1);
            },
            contentWayPoint() {
                let i = 0;
                if (
                    !$('.ftco-animate').hasClass('ftco-animated')) {

                    i++;

                    $('.ftco-animate').addClass('item-animate');
                    setTimeout(function () {

                        $('body .ftco-animate.item-animate').each(function (k) {
                            var el = $(this);
                            setTimeout(function () {
                                var effect = el.data('animate-effect');
                                if (effect === 'fadeIn') {
                                    el.addClass('fadeIn ftco-animated');
                                } else if (effect === 'fadeInLeft') {
                                    el.addClass('fadeInLeft ftco-animated');
                                } else if (effect === 'fadeInRight') {
                                    el.addClass('fadeInRight ftco-animated');
                                } else {
                                    el.addClass('fadeInUp ftco-animated');
                                }
                                el.removeClass('item-animate');
                            }, k * 50, 'easeInOutExpo');
                        });

                    }, 100);
                }
            },
            fetchCms() {

                let url = this.config.baseUrl + '/api/cms/';
                let currentObject = this;
                this.axios.get(url)
                    .then(function (response) {
                        // console.log(response);
                        if( response.status === 200 ) {
                            if(response.data) {
                                currentObject.cms = response.data;
                            }
                        } else {
                            console.log(response.statusText);
                        }
                    })
                    .catch(function (error) {
                        console.log(error);
                    });
            },

        },
        mounted: function () {
            this.fetchCms();
        }
    }
</script>
